#!/bin/sh

opencvrtc_deb_readme () {
cat <<'EOF'
opencvrtc for Debian
-----------------------
Debian package of openCV-2.0-component

 -- Hyundeok Lee <hyundeok.i@aist.go.jp> Mon, 21 Dec 2009 16:18:55 +0900
EOF
} 

opencvrtc_deb_changelog () {
cat <<'EOF'
opencvrtc (0.0.1) unstable; urgency=low

  * Initial release.
 -- Hyundeok Lee <hyundeok.i@aist.go.jp> Mon, 21 Dec 2009 16:18:55 +0900
EOF
}

opencvrtc_deb_compat () {
cat <<EOF
4
EOF
}

opencvrtc_deb_control () {
cat<<'EOF'
Source: opencvrtc
Section: main
Priority: extra
Maintainer: Hyundeok Lee <hyundeok.i@aist.go.jp>
Build-Depends: debhelper, libace-dev, omniidl4
Standards-Version: 3.7.2

Package: opencvrtc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenRTM-opecv20-component
EOF
}

opencvrtc_deb_copyright () {
cat <<'EOF'
This package was debianized by Hyundeok Lee <hyundeok.i@aist.go.jp> on

Upstream Author(s): 

    Hyundeok Lee <hyundeok.i@aist.go.jp>

Copyright: 

License:

    1) GPL
    
    2) Individual Licnese
    
The Debian packaging is (C) 2008, Hyundeok Lee <hyundeok.i@aist.go.jp>

# Please also look if there are files or directories which have a
# different copyright/license attached and list them here.
EOF
}

opencvrtc_deb_dirs () {
cat <<EOF
usr/bin
usr/sbin
EOF
}

opencvrtc_deb_docs () {
cat <<EOF
EOF
}

opencvrtc_deb_files () {
cat <<EOF
opencvrtc_0.0.1_i386.deb main extra
EOF
}

opencvrtc_deb_rules () {
cat <<'EOF'
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"


#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp:  config.status

#	touch $@

build-indep: build-indep-stamp
build-indep-stamp:  config.status

#	touch $@

clean:
#	dh_testdir
#	dh_testroot
#	rm -f build-arch-stamp build-indep-stamp #CONFIGURE-STAMP#

#	dh_clean 

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_clean -k -i 
	dh_installdirs -i
	#$(MAKE)
	#(cd $(CURDIR)/components ; $(MAKE) DESTDIR=$(CURDIR)/debian/opencvrtc install)
	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s 
	dh_installdirs -s

	# Add here commands to install the arch part of the package into 
	$(MAKE)

	#(cd $(CURDIR)       ; $(MAKE) DESTDIR=$(CURDIR)/debian/opencv20-component install)
	#(cd $(CURDIR)/rtm      ; $(MAKE) DESTDIR=$(CURDIR)/debian/opencvrtc install-exec)
	#(cd $(CURDIR)        ; $(MAKE) DESTDIR=$(CURDIR)/debian/opencvrtc install)
	(cd $(CURDIR)/components ; $(MAKE) DESTDIR=$(CURDIR)/debian/opencvrtc install)
	#(cd $(CURDIR)/rtm      ; $(MAKE) DESTDIR=$(CURDIR)/debian/opencvrtc uninstall)

	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
	dh_makeshlibs
	dh_installdeb
#	dh_shlibdeps -l/usr/local/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch 
EOF
}

export PATH=/usr/local/bin:/usr/bin:/bin:/usr/X11R6/bin:/usr/local/X11R6/bin:/usr/local/sbin:/usr/sbin:/sbin:
export LANG=C
export LC_ALL=C

# date
date=`date "+%y%m%d%H%M"`
time=/usr/bin/time
# package location and build directory
package=/usr/h-lee/deb/OpenCV.tar.gz
packagedir=OpenCV
package_date=`ls -al $package | awk '{printf("%s/%s %s\n",$6,$7,$8);}'`
package_date=`diff -ac $package /dev/null | head -1 |awk '{print $3,$4,$5,$6,$7,$8;}'`
package_name=`basename $package`
buildroot=/usr/h-lee/PackageBuild

logheader="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\"><html><body><pre>"
logfooter="</pre></body></html>"

# system information
hostname=`hostname`
os=`uname -s`
release=`uname -r`-`uname -p`

dist_name=""
dist_key=""
# Check the lsb distribution name
if test -f /etc/lsb-release ; then
    . /etc/lsb-release
    if test "x$DISTRIB_DESCRIPTION" != "x" ; then
	dist_name=$DISTRIB_DESCRIPTION-`uname -m`
	dist_key=$DISTRIB_ID
    fi
fi
# Check the Fedora version
if test "x$dist_name" = "x" && test -f /etc/fedora-release ; then
    dist_name=`cat /etc/fedora-release`-`uname -m`
    dist_key=`sed -e 's/.*\([0-9]\).*/fc\1/' /etc/fedora-release`
fi
#Check the Debian version
if test "x$dist_name" = "x" && test -f /etc/debian_version ; then
    dist_name="Debian"`cat /etc/debian_version`-`uname -m`
    dist_key="Debian"
fi
# Check the Vine version
if test "x$dist_name" = "x" && test -f /etc/vine-release ; then
    dist_name=`cat /etc/vine-release`-`uname -m`
    dist_key=`sed -e 's/.*\([0-9]\)\.\([0-9]\).*/vl\1\2/' /etc/vine-release`
fi
# Check the TuboLinux version
if test "x$dist_name" = "x" && test -f /etc/turbolinux-release ; then
    dist_name=`cat /etc/tubolinux-release`-`uname -m`
    dist_key=""
fi

if test "x$dist_name" = "x" ; then
    dist_name=$os$release
fi
# Check the RedHat/Fedora version
if test "x$dist_name" = "x" && test -f /etc/redhat-release ; then
    dist_name=`cat /etc/redhat-release`-`uname -m`
fi

# only fedora and vine
if test ! "x$dist_key" = "xDebian" -a ! "x$dist_key" = "xUbuntu" ; then
    echo $dist_key
    echo "This is not debian/ubuntu"
    exit 0
fi

echo $dist_key

distname=`echo $dist_name | sed 's/[ |\(|\)]//g'`
# system dependent build directory and log file name
builddir=$buildroot/$distname
timestamp=$buildroot/.$distname
logfile=$distname-$date.log

build=""
echo $dist_key
# check package
if test -f $package ; then
    echo "Package found: " $package
else
    echo "Package not found: " $pacakge
    exit 1
fi
cd $buildroot

# check if package is new
if test -f $timestamp ; then
    if test $package -nt $timestamp ; then
	build=yes
	echo "New source file was found."
        touch $timestamp
    fi
else
    echo "Timestamp not found."
    touch $timestamp
    build=yes
fi

if test "x$build" = "x" ; then
    echo "No new package."
    exit 1
fi

# cleanup 
echo "cleanup " $builddir/$packagedir
rm -rf $builddir

mkdir -p $builddir
cd $builddir

echo "distribution: " $dist_name >> $buildroot/$logfile
echo "package: $package_date " >> $buildroot/$logfile


#------------------------------------------------------------
# package build process
#------------------------------------------------------------
echo $logheader > $buildroot/make-$logfile

tar xvzf $package
mkdir $packagedir/debian
opencvrtc_deb_readme    > $packagedir/debian/README.Debian
opencvrtc_deb_changelog > $packagedir/debian/changelog
opencvrtc_deb_compat    > $packagedir/debian/compat
opencvrtc_deb_control   > $packagedir/debian/control
opencvrtc_deb_copyright > $packagedir/debian/copyright
opencvrtc_deb_dirs      > $packagedir/debian/dirs
opencvrtc_deb_docs      > $packagedir/debian/docs
opencvrtc_deb_files     > $packagedir/debian/files
chmod 444 $packagedir/debian/files
opencvrtc_deb_rules     > $packagedir/debian/rules
chmod 755 $packagedir/debian/rules

cd $packagedir

if $time -p -o make_time-$logfile dpkg-buildpackage -W -us -uc -rfakeroot >> $buildroot/make-$logfile 2>&1 ; then
    echo $logfooter >> $buildroot/make-$logfile
    make_time=`awk '/real/{printf("%s[s] ", $0);}' make_time-$logfile`
    echo "make: OK" >> $buildroot/$logfile
    echo "make_time: $make_time" >> $buildroot/$logfile
    rm -f make_time-$logfile
else
    echo "make: NG" >> $buildroot/$logfile
    rm -f make_time-$logfile
    exit 1
fi

