#------------------------------------------------------------
#
# @file RPM spec file for OpenRTM-aist
# @author Sangjae kim <sangjae.kim@aist.go.jp>
#
# $
#
%define pkgname        OpenCV-RTC
%define version        0.0.1
%define distname       fedora
%define builddir       %{_topdir}/BUILD/%{distname}
%define pkgver         0
%define dirname	       OpenCV
%define tarpath        OpenRTM-aist/Components

#------------------------------------------------------------
# Package information
Name:    OpenCV-RTC
Version: %{version}
Release: %{pkgver}.%{distname}
Summary: OpenCV-RTC: OpenCV2.0 - RTComponent
Group:   Development/Libraries
License: LGPL
URL:     http://www.is.aist.go.jp/rt/OpenRTM-aist/
Source0: %{pkgname}-%{version}.tar.gz
Vendor:  AIST

#------------------------------------------------------------
# Build environment
Prefix:        /usr
#Buildroot:     %{_tmppath}/%{pkgname}-%{version}-%{release}-root
#Buildroot:     %{_tmppath}/opencv_rtc-root
Buildroot:     %{_tmppath}/%{targetname} -root
#Requires:      cmake
#Requires:      openrtm
AutoReq: no
AutoReqProv: no
BuildRequires: python

%description
OpenRTM-aist is a reference implementation of RTC (Robotic Technology 
Component) specification which is OMG standard. OpenRTM-aist includes
RT-Middleware runtime environment and RTC framework. The OMG standard
defines a component model and certain important infrastructure services
applicable to the domain of robotics software development.
OpenRTM-aist is being developed and distributed by 
Task Intelligence Research Group, Intelligent Systems Research Institute, 
National Institute of Advanced Industrial Science and Technology (AIST), Japan. 
Please see http://www.is.aist.go.jp/rt/OpenRTM-aist/html/ for more detail. 

#------------------------------------------------------------
# prep section
%prep
%{__rm} -rf %{buildroot}
%setup -n %{dirname} -q

#------------------------------------------------------------
# build section
%build
%configure 
%{__make}

#------------------------------------------------------------
# install section
%install
%{__make} DESTDIR=%{buildroot} install
%{__cp} -R ./rtm/idl/.libs/*.a %{buildroot}/usr/share/include/rtm/idl
%{__cp} ./components/Affine/rtc.conf %{buildroot}/usr/share/%{tarpath}/%{dirname}

#---------------------------------------------------------
# clean section
%clean
%{__rm} -rf %{buildroot}

#------------------------------------------------------------
#package file list
%files
%defattr(-,root,root,-)
%attr(755,root,root)
/usr/share/include/rtm/idl
%{_datadir}/%{tarpath}/%{dirname}/*Comp*
%{_datadir}/%{tarpath}/%{dirname}/*.conf
%{_datadir}/%{tarpath}/%{dirname}/src
%{_datadir}/%{tarpath}/%{dirname}/rtcs

#------------------------------------------------------------
# changelog section
%changelog
* Thu Jan 05 2010 Sangjae Kim <sangjae.kim@aist.go.jp> - 0.0.1-RTC
- OpenCV-RTC-0.0.1
